import 'package:firebase_core/firebase_core.dart';
import 'package:flutter/material.dart';
import 'package:flutter_facebook_auth/flutter_facebook_auth.dart';
import 'package:flutter/foundation.dart' show kIsWeb;
import 'package:impact/0_Impact_Global/1_Get_Data_SP.dart';
import 'package:impact/0_Impact_Global/2_Shared_Preference.dart';
import 'package:impact/0_Impact_Global/3_Set_Text_Direction.dart';
import 'package:impact/0_Impact_Global/4_Set_Theme.dart';
import 'package:impact/0_Impact_Global/5_Get_Platform.dart';
import 'package:impact/0_Impact_Global/6_Set_Lang.dart';


class ImpactInitPage extends StatefulWidget {
  var RedirectTo;

  ImpactInitPage(
      this.RedirectTo
  );

  @override
  State<StatefulWidget> createState() {
    return ImpactInitPageState();
  }
}

class ImpactInitPageState extends State<ImpactInitPage> {
  @override
  Widget build(BuildContext context) {

    WidgetsBinding.instance?.addPostFrameCallback((_) async {
      try{
        await Firebase.initializeApp();
      }
      catch(e){
        print("~~~~~~~~~~Impact Firebase Connecting Failed~~~~~~~~~~~~~~~");
        print("Unhandled Exception: [core/not-initialized] Firebase has not been correctly initialized. Have you added the google-services.json file to the project? ");
        print("~~~~~~~~~~Impact Firebase Connecting Failed~~~~~~~~~~~~~~~");
      }
      ImpactGetPlatform();
      ImpactScreenWidth  = MediaQuery.of(context).size.width;
      ImpactScreenHeight = MediaQuery.of(context).size.height;
      await ImpactGetDataSP();
      ImpactSetTheme();
      ImpactSetLang();
      ImpactSetTextDirection();

      if (kIsWeb) {
        FacebookAuth.instance.webInitialize(
          appId: "1329834907365798",
          cookie: true,
          xfbml: true,
          version: "v11.0",
        );
      }


      Navigator.of(context).pushReplacement(MaterialPageRoute(builder:(context)=>this.widget.RedirectTo));
    });


    return Scaffold(
      body:Center(
        child:CircularProgressIndicator(),
      ),
    );
  }

}