import 'package:flutter/material.dart';
import 'package:impact/9_Page_Selectors/1_Impact_PS_1/2_Widgets/2_Buttons/Button_NotNow.dart';
import 'package:impact/9_Page_Selectors/1_Impact_PS_1/2_Widgets/2_Buttons/NextButton.dart';

class ImpactPageSelector1 extends StatefulWidget {
  List<Widget>? PagesContent;
  var RedirectTo;
  Color? ActiveTabPageSelectorColor;
  Color? TabPageSelectorColor;

  ImpactPageSelector1({
    required this.PagesContent,
    required this.RedirectTo,
    required this.ActiveTabPageSelectorColor,
    required this.TabPageSelectorColor,
  });

  @override
  State<StatefulWidget> createState() {
    return ImpactPageSelector1State();
  }
}


class ImpactPageSelector1State extends State<ImpactPageSelector1> with SingleTickerProviderStateMixin {
   TabController? PageSelectorTabController;

  @override
  void initState(){
    super.initState();
    PageSelectorTabController = new TabController(
        length: this.widget.PagesContent!.length,
        vsync: this,
        initialIndex:0
    );
    PageSelectorTabController?.addListener(() {
      setState(() {

      });
    });
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      body: DefaultTabController(
        initialIndex:0,
        length:this.widget.PagesContent!.length,
        child: Builder(
          builder: (BuildContext context){

            return Stack(
              children: <Widget>[
                Container(
                  width:MediaQuery.of(context).size.width,
                  height: MediaQuery.of(context).size.height,
                  child: TabBarView(
                    controller:PageSelectorTabController,
                    children: <Widget>[
                      for(int i=0;i<this.widget.PagesContent!.length;i++)
                        this.widget.PagesContent![i],
                    ],
                  ),
                ),
                Padding(
                  padding: EdgeInsets.only(
                      top:MediaQuery.of(context).size.height*0.7
                  ),
                  child: Container(
                      child:Center(
                        child:TabPageSelector(
                          controller:PageSelectorTabController,
                          color:this.widget.TabPageSelectorColor,
                          selectedColor:this.widget.ActiveTabPageSelectorColor,
                        ),
                      )
                  ),
                ),

                Container(
                    child:Column(children: <Widget>[
                      SizedBox(height:MediaQuery.of(context).size.height*0.9,),
                      Row(
                        mainAxisAlignment:MainAxisAlignment.spaceBetween,
                        children: <Widget>[
                          ImapactPS1ButtonNext(
                            parent:this,
                            RedirectTo:this.widget.RedirectTo,
                          ),
                          (PageSelectorTabController!.index==0)?SizedBox():PageSelectorButtonNotNow(
                            Redirecto:this.widget.RedirectTo,
                          ),
                        ],
                      )
                    ],)
                ),


              ],
            );
          }
        ),
      ),
    );
  }

}