import 'package:flutter/material.dart';
import 'package:impact/0_Impact_Global/2_Shared_Preference.dart';

class ImpactPageSelector2Item {
  var image,title,description;

  ImpactPageSelector2Item({
    required  this.image,
    required  this.title,
    required  this.description,
  });

}


class ImpactPageSelector2 extends StatefulWidget{
  var RedirectTo;
  List<ImpactPageSelector2Item> PageContents;
  LinearGradient? MainGrad;
  RadialGradient? RadialGrad;
  Color? ActiveTabPageSelectorColor;
  Color? TabPageSelectorColor;

  ImpactPageSelector2({
    required  this.RedirectTo,
    required  this.PageContents,
    required  this.MainGrad,
    required  this.RadialGrad,
    required  this.ActiveTabPageSelectorColor,
    required  this.TabPageSelectorColor,
  });

  ImpactPageSelector2State createState() => ImpactPageSelector2State();
}

class ImpactPageSelector2State extends State<ImpactPageSelector2> {
  int ControllerIndex=0;

  @override
  void initState(){
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      body:Container(
        width:MediaQuery.of(context).size.width,
        height:MediaQuery.of(context).size.height,
        decoration:BoxDecoration(
          gradient:this.widget.MainGrad!
        ),
        child:DefaultTabController(
          length:this.widget.PageContents.length,
          child: Builder(
            builder: (BuildContext context) => Stack(
              children: <Widget>[




                Container(
                  width:MediaQuery.of(context).size.width,
                  height: MediaQuery.of(context).size.height,
                  child: TabBarView(
                    physics: NeverScrollableScrollPhysics(),
                    children: <Widget>[
                      for(int i=0 ; i<this.widget.PageContents.length; i++)
                        Column(
                          children: <Widget>[
                            Container(
                              width:330,
                              height:330,
                              decoration: BoxDecoration(
                                //Applying Radial Gradient
                                gradient:this.widget.RadialGrad
                              ),
                              //Take Centered Image With Width And Height 90x90
                              child:Center(
                                child:Image.network(
                                  this.widget.PageContents[i].image.toString(),
                                  width :90,
                                  height:90,
                                ),
                              ),
                            ),
                            Text(
                              this.widget.PageContents[i].title,
                              textDirection:TextDirection.ltr,
                              style:TextStyle(
                                color:Colors.white,
                                fontSize:20,
                              ),
                            ),
                            //Row3 Take Description Ar Or En Based On Language
                            Padding(
                              padding: const EdgeInsets.only(left:40,right:40,top:10),
                              child: Text(
                                this.widget.PageContents[i].description,
                                textDirection:TextDirection.ltr,
                                style:TextStyle(
                                  color:Colors.white,
                                  fontSize:16,
                                ),
                              ),
                            ),
                          ],
                        ),
                    ],
                  ),
                ),

                Padding(
                  padding:EdgeInsets.only(top:MediaQuery.of(context).size.height*0.7),
                  child: Container(
                      child:Center(
                        child:TabPageSelector(
                          color:this.widget.TabPageSelectorColor,
                          selectedColor:this.widget.ActiveTabPageSelectorColor,
                        ),
                      )
                  ),
                ),

                //Finally  Placing Next And Prev Button Padded From Top
                // 90% Of Screen Height Appear From Bottom
                Padding(
                  padding:EdgeInsets.only(top:MediaQuery.of(context).size.height*0.9),
                  child: Padding(
                    padding: const EdgeInsets.only(left:30,right:30),
                    //Padded Row By 30 Left And Right
                    child: Row(
                      //Space Between Buttons
                      mainAxisAlignment:MainAxisAlignment.spaceBetween,
                      children: [

                        //If Page Is 0 Hide Next Button
                        //Gesture Detector Detect Tap On Button Prev
                        (ControllerIndex==0)?SizedBox(width:120,):GestureDetector(
                          onTap:(){
                            //Each Tap On Button Every 400 milliseconds
                            Future.delayed(const Duration(milliseconds: 400), () {
                              //Get TabController
                              final TabController controller = DefaultTabController.of(context)!;
                              //If Not Changing And Not 0 Switch To Previous Page By -1
                              if (!controller.indexIsChanging && controller.index!=0 ) {
                                controller.animateTo(controller.index-1);
                                setState(() {
                                  ControllerIndex--;
                                });
                              }
                            });
                          },
                          //Container Of The Button
                          child:Container(
                              width: 105,
                              height: 40,
                              decoration:BoxDecoration(
                                  color:Color.fromRGBO(105, 101, 207,1),
                                borderRadius: BorderRadius.all(Radius.circular(80.0))
                              ),
                              padding: const EdgeInsets.fromLTRB(20, 10, 20, 10),
                              child:Center(
                                child:Text(
                                  "Previous",
                                  style:TextStyle(
                                    color:Colors.white,
                                    fontWeight:FontWeight.bold,
                                  ),
                                ),
                              )
                          ),
                        ),


                        GestureDetector(
                          onTap:(){
                            Future.delayed(const Duration(milliseconds: 400), () async {
                              if(ControllerIndex<=0){
                                setState(() {
                                  ControllerIndex=0;
                                });
                              }
                              final TabController controller = DefaultTabController.of(context)!;
                              if (!controller.indexIsChanging && controller.index!=this.widget.PageContents.length-1 ) {
                                controller.animateTo(controller.index+1);
                                ControllerIndex++;
                              }
                              else{
                                ImpactPageSelectorLoaded="Saved";
                                await ImpactSaveAndGetAllInfo();
                                Navigator.pushReplacement(context,MaterialPageRoute(builder:(context)=>this.widget.RedirectTo));
                              }
                            });
                          },
                          child:Container(
                              width: 105,
                              height: 40,
                              decoration:BoxDecoration(
                                  color:Color.fromRGBO(105, 101, 207,1),
                                  borderRadius: BorderRadius.all(Radius.circular(80.0))
                              ),
                              padding: const EdgeInsets.fromLTRB(20, 10, 20, 10),
                              child:Center(
                                child:Text(
                                  "Next",
                                  style:TextStyle(
                                    color:Colors.white,
                                    fontWeight:FontWeight.bold,
                                  ),
                                ),
                              ),
                          ),
                        ),
                      ],
                    ),
                  ),
                ),




                Container(
                  width:MediaQuery.of(context).size.width,
                  height:90,
                  child:Align(
                    alignment:Alignment.centerRight,
                    child:Padding(
                      padding: const EdgeInsets.all(8.0),
                      child: FlatButton(
                        child:Text(
                          "Skip >>",
                          style:TextStyle(
                              color:Colors.white
                          ),
                        ),
                        onPressed:() async {
                          ImpactPageSelectorLoaded="Saved";
                          await ImpactSaveAndGetAllInfo();
                          Navigator.pushReplacement(context,MaterialPageRoute(builder:(context)=>this.widget.RedirectTo));
                        },
                      ),
                    ),
                  ),
                ),

              ],
            ),
          ),
        ),
      )
    );
  }
}





