import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:impact/0_Impact_Global/2_Shared_Preference.dart';
import 'package:impact/2_Buttons/1_Impact_Button_1.dart';
import 'package:impact/8_Component/2_Wave_Clipper_1.dart';


class ImpactPageSelector3Item {
  var image,title,description;

  ImpactPageSelector3Item({
    required this.image,
    required this.title,
    required this.description,
  });

}


class ImpactPageSelector3 extends StatefulWidget{
  var RedirectTo;
  List<ImpactPageSelector3Item> PageContents;
  Color? ActiveTabPageSelectorColor;
  Color? TabPageSelectorColor;

   ImpactPageSelector3 ({
     required this.RedirectTo,
     required this.PageContents,
     required this.ActiveTabPageSelectorColor,
     required this.TabPageSelectorColor,
   });

  ImpactPageSelector3State createState() => ImpactPageSelector3State();
}

class ImpactPageSelector3State extends State<ImpactPageSelector3> {
  int SelectedIndexPage=0;
  var Wave=WaveClipperOne(flip:false,reverse: true);

  @override
  Widget build(BuildContext context) {
    return Scaffold(
        body:DefaultTabController(
          length:3,
          child: Builder(
              builder: (BuildContext context ) => Stack(
                children: [

                  TabBarView(
                    physics:NeverScrollableScrollPhysics(),
                    children: [

                      for(int i=0;i<this.widget.PageContents.length;i++)
                      Container(
                          width:MediaQuery.of(context).size.width,
                          height:MediaQuery.of(context).size.height,
                          color:ImpactPrimaryColor,
                          child:Column(
                            children: [
                              SizedBox(height:35,),
                              Center(
                                  child:Container(
                                    width:300,
                                    height:200,
                                    child:Padding(
                                      padding: const EdgeInsets.only(left:18,right:18),
                                      child: Column(
                                        mainAxisAlignment:MainAxisAlignment.center,
                                        crossAxisAlignment:CrossAxisAlignment.center,
                                        children: [
                                          Text(
                                            this.widget.PageContents[i].title,
                                            style:TextStyle(
                                              color:Colors.white,
                                              fontSize:17,
                                            ),
                                          ),
                                          SizedBox(height:10,),
                                          Padding(
                                            padding: const EdgeInsets.only(left:0),
                                            child: Text(
                                              this.widget.PageContents[i].description,
                                              textAlign:TextAlign.center,
                                              style:TextStyle(
                                                color:Colors.white,
                                                fontSize:12,
                                              ),
                                            ),
                                          )
                                        ],
                                      ),
                                    ),
                                  )
                              ),
                              Image.network(
                                this.widget.PageContents[i].image,
                                width:120,
                                height:120,
                              ),

                            ],
                          )
                      ),


                    ],
                  ),
                  Container(
                      width:MediaQuery.of(context).size.width,
                      height:MediaQuery.of(context).size.height,
                      child:Column(
                        children: [
                          SizedBox(height:MediaQuery.of(context).size.height*0.65),
                          Container(
                            height:MediaQuery.of(context).size.height*0.35,
                            child:Column(
                              children: [
                                ClipPath(
                                    clipper:Wave,
                                    child:Container(
                                      width:MediaQuery.of(context).size.width,
                                      height:MediaQuery.of(context).size.height*0.35,
                                      color:Colors.white,
                                      child:Column(
                                        children: [
                                          SizedBox(height:MediaQuery.of(context).size.height*0.1,),
                                          Row(
                                            mainAxisAlignment:MainAxisAlignment.spaceBetween,
                                            children: [

                                              (SelectedIndexPage==0)?SizedBox(width:120,):Padding(
                                                padding: const EdgeInsets.only(left:35),
                                                child: ImpactButton1(
                                                    Txt:"Prev",
                                                    TxtColor:Colors.white,
                                                    W: 100.0,
                                                    H: 40.0,
                                                    Do:(){
                                                      if(SelectedIndexPage<=0){
                                                        setState(() {
                                                          SelectedIndexPage=0;
                                                        });
                                                      }
                                                      Future.delayed(const Duration(milliseconds: 400), () {
                                                        if(SelectedIndexPage%2==0){
                                                          setState(() {
                                                            Wave=WaveClipperOne(flip:false,reverse: true);
                                                          });

                                                        }
                                                        else{
                                                          setState(() {
                                                            Wave=WaveClipperOne(flip:true,reverse: true);
                                                          });
                                                        }
                                                        if(SelectedIndexPage<=0){
                                                          setState(() {
                                                            SelectedIndexPage=0;
                                                          });
                                                        }
                                                        final TabController controller = DefaultTabController.of(context)!;
                                                        if (!controller.indexIsChanging && controller.index!=0 ) {
                                                          controller.animateTo(controller.index-1);
                                                          print(controller.index);
                                                          SelectedIndexPage--;
                                                        }

                                                      });

                                                    }
                                                ),
                                              ),
                                              Padding(
                                                padding: const EdgeInsets.only(right:35),
                                                child: ImpactButton1(
                                                    Txt:"Next",
                                                    TxtColor:Colors.white,
                                                    W: 100.0,
                                                    H: 40.0,
                                                    Do:(){

                                                      if(SelectedIndexPage<=0){
                                                        setState(() {
                                                          SelectedIndexPage=0;
                                                        });
                                                      }
                                                      Future.delayed(const Duration(milliseconds: 400), () async {
                                                        if(SelectedIndexPage%2==0){
                                                          setState(() {
                                                            Wave=WaveClipperOne(flip:false,reverse: true);
                                                          });

                                                        }
                                                        else{
                                                          setState(() {
                                                            Wave=WaveClipperOne(flip:true,reverse: true);
                                                          });
                                                        }
                                                        final TabController controller = DefaultTabController.of(context)!;
                                                        if (!controller.indexIsChanging && controller.index!=2 ) {
                                                          controller.animateTo(controller.index+1);
                                                          print(controller.index);
                                                          SelectedIndexPage++;
                                                        }
                                                        else{
                                                          ImpactPageSelectorLoaded = "Saved";
                                                          await ImpactSaveAndGetAllInfo();
                                                          Navigator.pushReplacement(context,MaterialPageRoute(builder:(context)=>this.widget.RedirectTo));
                                                        }
                                                      });
                                                    }
                                                ),
                                              ),

                                            ],

                                          ),
                                          SizedBox(height:MediaQuery.of(context).size.height*0.05,),
                                          TabPageSelector(
                                            selectedColor:this.widget.ActiveTabPageSelectorColor,
                                            color:this.widget.TabPageSelectorColor,
                                          ),
                                          Expanded(child: Align(
                                            alignment:Alignment.bottomRight,
                                            child:TextButton(
                                              child:Text(
                                                "Skip"
                                                ,style: TextStyle(color: Colors.purple[800],fontSize: 20,fontWeight: FontWeight.bold),),
                                              onPressed:() async {
                                                Navigator.push(context,MaterialPageRoute(builder:(context)=>this.widget.RedirectTo));
                                              },
                                            ),
                                          ),
                                          ),
                                        ],
                                      ),
                                    )
                                ),

                              ],
                            ),
                          )
                        ],
                      )
                  ),



                ],
              )



          ),
        )

    );

  }

}



